<?php


class My_WC_Cart { //Class Begins

	function __construct(){
		add_action('woocommerce_settings_tabs_array', array($this,'add_tab')); /* Add Tab */
		add_action( 'woocommerce_settings_tabs_quivers_settings', array($this,'load_form') ); /* Load Form */
		add_action( 'woocommerce_update_options_quivers_settings', array($this, 'update_settings') ); /* Save Settings */
		add_action( 'woocommerce_cart_calculate_fees', array($this, 'checkout_billing') ); /* Tax Calc */
	
		add_action( 'woocommerce_checkout_create_order_line_item', array($this,'ektgn_meta_to_line_item'), 20, 4 ); 
		add_filter('woocommerce_hidden_order_itemmeta', array($this,'custom_woocommerce_hidden_order_itemmeta'), 10, 1);
	}

	function custom_woocommerce_hidden_order_itemmeta($arr){
		$arr[] = '_item_tax_value';
   		return $arr;
	}

	function ektgn_meta_to_line_item( $item, $cart_item_key, $values, $order )
	{
	    $_p = $item->get_product();
	    $key = '_item_tax_value';
	 	$val = isset($this->qqq['q_tax'][$values['product_id']][$values['variation_id']]) ? json_encode($this->qqq['q_tax'][$values['product_id']][$values['variation_id']]) : 0;
	    if ( false !== ( $value = $_p->get_meta( $key, true ) ) )
	    {
	        $item->add_meta_data( $key , $val , true ); 
	    }
	                 
	}	

	function checkout_billing(){
		if(is_checkout() || is_cart()){
			//1.Model Data
				$data = $this->model_data(WC()->cart);

			//2.CallAPI when shipping address
				if(sizeof($data['items']) > 0){
					$test = 'test';
					if(get_option('wc_settings_tab_demo_sandbox_status') == 'no') $test = '';
					$res = $this->CallAPI( "POST", "https://api.quivers" . $test . ".com/v1/CustomerOrders/Validate", json_encode($data) );
					$res = json_decode($res['data'],true);
				} else{
					$res['result']['items'] = [];
				}

			//3.UPDATE $cart_obj
				if(isset($res['result'])){
					$this->setTaxesFee($res['result']);
                    $this->setStatementDescriptor($res['result']['statementDescriptor']);
				}else{
					
				}
		}
	}

    function setStatementDescriptor($statement_descriptor){
        // set statement descriptor as a session attribute
        WC()->session->set('my_session_var_name', array('statement' => $statement_descriptor));
    }

	function setTaxesFee($ci) {
		$fees_add = 0;
		$q_tax = [];
		if(isset($ci['items']) && sizeof($ci['items']) > 0){
			foreach ($ci['items'] as $prod) {
				foreach ($prod['pricing']['taxes'] as $k => $value) {
					$variationRefId = $prod['variantRefId'] == '' ? 0 : $prod['variantRefId'];
					$q_tax['q_tax'][$prod['productRefId']][$variationRefId] = isset($value['amount']) && $value['amount'] > 0 ? $value['amount'] : 0;
					$fees_add += isset($value['amount']) && $value['amount'] > 0 ? $value['amount'] : 0;
				}
			}
			$this->qqq = $q_tax;
			WC()->cart->add_fee( __('Tax', 'woocommerce'), $fees_add, false );
		} else{
			
		}
	}

	function add_tab($settings_tabs){
		$settings_tabs['quivers_settings'] = __( 'Quivers', 'woocommerce-quivers_settings' );
		do_action('quivers_add_tab');
		return $settings_tabs;
	}

	function load_form() {
		 woocommerce_admin_fields( $this->get_settings() );
	}

	function get_settings() {
		$settings = array(
	        'quivers_settings' => array(
	            'name'     => __( 'Quivers Integration Settings', 'woocommerce-quivers_settings' ),
	            'type'     => 'title',
	            'desc'     => '',
	            'id'       => 'wc_settings_tab_demo_section_title'
	        ),
	        'marketplaceId' => array(
	            'name' => __( 'Marketplace Id:', 'woocommerce-quivers_settings' ),
	            'type' => 'text',
	            'id'   => 'wc_settings_tab_demo_marketplaceId'
	        ),
	        'claiming_groups' => array(
	            'name' => __( 'Claiming Groups:', 'woocommerce-quivers_settings' ),
	            'type' => 'text',
	            'id'   => 'wc_settings_tab_demo_claiming_groups',
	        ),
	        'apikey' => array(
	            'name' => __( 'Quivers API key:', 'woocommerce-quivers_settings' ),
	            'type' => 'text',
	            'id'   => 'wc_settings_tab_demo_apikey'
	        ),
	        'business_refid' => array(
	            'name' => __( 'Business RefId:', 'woocommerce-quivers_settings' ),
	            'type' => 'text',
	            'id'   => 'wc_settings_tab_demo_business_refid'
	        ),
	        'wp_base_url' => array(
	            'name' => __( 'WP Integration Base URL:', 'woocommerce-quivers_settings' ),
	            'type' => 'text',
	            'id'   => 'wc_settings_tab_demo_wp_base_url'
	        ),
			'wp_username' => array(
	            'name' => __( 'WP Integration Username:', 'woocommerce-quivers_settings' ),
	            'type' => 'text',
	            'id'   => 'wc_settings_tab_demo_wp_username'
	        ),
	        'wp_auth_token' => array(
	            'name' => __( 'WP Integration Auth Token:', 'woocommerce-quivers_settings' ),
	            'type' => 'text',
	            'id'   => 'wc_settings_tab_demo_wp_auth_token'
	        ),
	        'sandbox_status' => array(
	            'name' => __( 'Quivers Sandbox Enabled:', 'woocommerce-quivers_settings' ),
	            'type' => 'select',
	            'id'   => 'wc_settings_tab_demo_sandbox_status',
	            'options'       => array(
			    	'yes'		=> __( 'Yes', 'wps' ),
			        'no'	=> __( 'No', 'wps' )
			    )
	        ),
	        'section_end' => array(
	             'type' => 'sectionend',
	             'id' => 'wc_settings_tab_demo_section_end'
	        )
	    );
	    return apply_filters( 'wc_settings_tab_demo_settings', $settings );
	}

	function sendDatatoAPI($result){
		$payload = array(
			"quivers_api_key" => "apikey ".$result['apikey'],
			"merchant_ref_id" => $result['business_refid'],
			"quivers_extra_data" => array(
				"ProductGroupId" => $result['claiming_groups'],
				"marketplaceId" => $result['marketplaceId']
			),
			"client_type" => "WooCommerce",
			"client_auth_object" => array(
				"consumer_secret" => $result['wp_auth_token'],
				"consumer_key" => $result['wp_username'],
				"url" => $result['wp_base_url']
			),
			"client_extra_data" => array(),
			'relay_orders_to_quivers' => true,
			'auto_claim_on_brand_available' => true,
			'hold_unhold_rule_on_order_claim' => true
			);
		$test = 'test';
		if(get_option('wc_settings_tab_demo_sandbox_status') == 'no') $test = '';
		
		$response = $this->CallAPI("POST", "https://konect.quivers" . $test . ".com/clients/profile/", json_encode($payload));
		
		if($response['httpcode'] != 201){
			echo "<div class='error notice'><p><strong>Unable to sync settings with quivers. Reason - ".explode("\"", $response['data'])[1]."</strong></p></div>";
		} 
		// print_r(json_encode($response));
	}

	function update_settings() {
		woocommerce_update_options( $this->get_settings() );

		$result['apikey'] = get_option('wc_settings_tab_demo_apikey');
		$result['business_refid'] = get_option('wc_settings_tab_demo_business_refid');
		$result['claiming_groups'] = get_option('wc_settings_tab_demo_claiming_groups');
		$result['marketplaceId'] = get_option('wc_settings_tab_demo_marketplaceId');
		$result['wp_auth_token'] = get_option('wc_settings_tab_demo_wp_auth_token');
		$result['wp_username'] = get_option('wc_settings_tab_demo_wp_username');
		$result['wp_base_url'] = get_option('wc_settings_tab_demo_wp_base_url');
		
		$this->sendDatatoAPI($result);
	}

	function model_data( $input ){
		$data = [];

		set_error_handler(array($this,'exceptions_error_handler'));
		try{
			$data['marketplaceId'] = get_option('wc_settings_tab_demo_marketplaceId');
			$data['shippingAddress']['firstname'] = WC()->customer->get_shipping_first_name();
			$data['shippingAddress']['lastname'] = WC()->customer->get_shipping_last_name();
			$data['shippingAddress']['email'] = WC()->customer->get_billing_email();
			$data['shippingAddress']['company'] = WC()->customer->get_shipping_company();
			$data['shippingAddress']['phoneNumber'] = WC()->customer->get_billing_phone();
			$data['shippingAddress']['line1'] = WC()->customer->get_shipping_address_1();
			$data['shippingAddress']['line2'] = WC()->customer->get_shipping_address_2();
			$data['shippingAddress']['city'] = WC()->customer->get_shipping_city();
			$data['shippingAddress']['postCode'] = WC()->customer->get_shipping_postcode();
			$data['shippingAddress']['country'] = WC()->customer->get_shipping_country();
			$data['shippingAddress']['region'] = WC()->customer->get_shipping_state();

			$prods = $input->get_cart();
			foreach($prods as $prod => $values){

				$_product =  wc_get_product( $values['data']->get_id() );
		
				$prod_var_opt = array();
				if(sizeof($values['variation']) > 0){
					$i=0;
					foreach ($values['variation'] as $key => $value) {
						$prod_var_opt[$i]["name"] = $key;
						$prod_var_opt[$i]["value"]["name"] = $value;
						$i++;
					}
				}

				$shipping_fees = array();

				$shipping_fees["name"] = "FedEx 2-Day";
					$amount = strip_tags(WC()->cart->get_cart_shipping_total());
				$shipping_fees["amount"] = (float)substr($amount,5,strlen($amount))/sizeof($prods);

				$pricing_disc = array();
				$i=0;
				if(sizeof(WC()->cart->get_applied_coupons()) > 0){
					foreach (WC()->cart->get_applied_coupons() as $coupon_code) {	
				 		$coupon_post_obj = get_page_by_title($coupon_code, OBJECT, 'shop_coupon');
						$coupons_obj = new WC_Coupon($coupon_post_obj->ID);
						$pricing_disc[$i]["name"] = $coupon_code;
						$pricing_disc[$i]["code"] = $coupon_code;
						// $pricing_disc[$i]["rate"] = $coupons_obj->get_amount();
						if ( $coupons_obj->get_discount_type() == 'percent' ){
							// Get the coupon object amount
							$pricing_disc[$i]["amount"] = -($coupons_obj->get_amount()/100)*($values['quantity']*get_post_meta($values['product_id'] , '_price', true));
						} elseif($coupons_obj->get_discount_type() == 'fixed_cart'){
							$pricing_disc[$i]["amount"] = -$coupons_obj->get_amount()/sizeof($prods);
						} elseif($coupons_obj->get_discount_type() == 'fixed_product'){
							$pricing_disc[$i]["amount"] = -$coupons_obj->get_amount();
						}

						$i++;
					}
				}
				$items = array();
				$items["product"]["name"] = $_product->get_title();
				// $items["product"]["key"] = $prod;
				$items["product"]["refId"] = $values['product_id'];
				$items["product"]["variant"]["name"] = $_product->get_name();
				$items["product"]["variant"]["refId"] = $values['variation_id'];
				$items["product"]["variant"]["option"][] = $prod_var_opt;
				$items["quantity"] = (int)$values['quantity'];
				$type_id = $values['variation_id'] == 0 ? $values['product_id'] : $values['variation_id'];
				$items["pricing"]["unitPrice"] = (int)get_post_meta($type_id , '_price', true);
				$items["pricing"]["salePrice"] = (int)get_post_meta($type_id , '_sale_price', true);
				$items["pricing"]["shippingFees"][] = $shipping_fees;
				$items["pricing"]["customFees"] = [];
				if(sizeof(WC()->cart->get_applied_coupons()) > 0) $items["pricing"]["discounts"] = $pricing_disc;


				$data["items"][] = $items;
			}
		} catch(Exception $e){
			restore_error_handler();
		}
		restore_error_handler();

		return $data;
	}
	////////////////////////////////////////////////////////////////////////////
	/////////////////////////Important Functions////////////////////////////////
	////////////////////////////////////////////////////////////////////////////
	function CallAPI($method, $url, $data = false)
	{
		$curl = curl_init();

		switch ($method)
		{
			case "POST":
				curl_setopt($curl, CURLOPT_POST, 1);
				 curl_setopt( $curl, CURLOPT_HTTPHEADER, array('Content-Type:application/json'));
				if ($data)
					curl_setopt($curl, CURLOPT_POSTFIELDS, $data);
				break;
			case "PUT":
				curl_setopt($curl, CURLOPT_PUT, 1);
				break;
			default:
				if ($data)
					$url = sprintf("%s?%s", $url, http_build_query($data));
		}

		curl_setopt($curl, CURLOPT_URL, $url);
		curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);

		$result = curl_exec($curl);
		$httpcode = curl_getinfo($curl, CURLINFO_HTTP_CODE);
		$res = [];
		$res['data'] = $result;
		$res['httpcode'] = @$httpcode;

		return $res;
	}

	function add_menu_items() {
		add_menu_page('Settings','Quivers','manage_options','quivers_taxes',array($this,'load_form'));
	}

	function exceptions_error_handler($severity, $message, $filename, $lineno) {
		if ($severity) {
			throw new ErrorException($message, 0, $severity, $filename, $lineno);
		}
	}
	/*--------------------------------ENDS---------------------------------*/					

}//Class Ends

// finally instantiate our plugin class and add it to the set of globals
if( class_exists("My_WC_Cart") ) $GLOBALS['my_wc_cart'] = new My_WC_Cart();

?>